Loading...
Searching...
No Matches
ExternalVariable Struct Reference

ExternalVariable represent any access to external (custom) data, typically associated with the '$' symbol syntax. Note that the AST does not store any additional information on the given external other than its name and type, which together form a unique external identifier known as the ExternalVariable 'token'. This token is used by the compiler to map user provided values to these external values. More...

`#include <openvdb_ax/ast/AST.h>`

Inheritance diagram for ExternalVariable:

## Public Types

using | UniquePtr = std::unique_ptr<ExternalVariable>

enum

NodeType {
TreeNode , StatementListNode , BlockNode , ConditionalStatementNode ,
CommaOperatorNode , LoopNode , KeywordNode , AssignExpressionNode ,
CrementNode , UnaryOperatorNode , BinaryOperatorNode , TernaryOperatorNode ,
CastNode , AttributeNode , FunctionCallNode , ExternalVariableNode ,
DeclareLocalNode , ArrayPackNode , ArrayUnpackNode , LocalNode ,
ValueBoolNode , ValueInt16Node , ValueInt32Node , ValueInt64Node ,
ValueFloatNode , ValueDoubleNode , ValueStrNode
}

| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr = std::shared_ptr<Node>

## Public Member Functions

| ExternalVariable (const std::string &name, const tokens::CoreType type)
| Construct a new ExternalVariable with a given name and type.
| ExternalVariable (const std::string &name, const std::string &token)
| Construct a new ExternalVariable with a given name and type/token string, delegating construction to the above ExternalVariable constructor.
| ExternalVariable (const ExternalVariable &other)
| Deep copy constructor for a ExternalVariable.
| ~ExternalVariable () override=default
ExternalVariable * | copy () const override final
| The deep copy method for a Node.
NodeType | nodetype () const override
| Virtual method for accessing node type information.
const char * | nodename () const override
| Virtual method for accessing node name information.
const char * | subname () const override
| Virtual method for accessing node name information.
const Variable * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.
tokens::CoreType | type () const
| Access the type that was used to access this external variable.
std::string | typestr () const
| Get the access type as a front end AX type/token string.
const std::string | tokenname () const
| Construct and return the full external token identifier. See ExternalVariable::tokenFromNameType.
size_t | children () const override
| Virtual method for accessing child information. Returns the number of children a given AST node owns.
const Node * | child (const size_t) const override
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.
const std::string & | name () const
Name/Type
template<typename NodeT>
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().
Child Queries
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.
virtual bool | replacechild (const size_t index, Node *node)
| Virtual method that attempted to replace a child at a given index with a provided node type.
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent.
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used.

## Static Public Member Functions

static char | symbolseparator ()
| Static method returning the symbol associated with an ExternalVariable access as defined by AX Grammar.
static std::string | tokenFromNameType (const std::string &name, const tokens::CoreType type)
| Static method returning the full unique external token identifier by consolidating its name and type such that token = tokenstr + '$' + name, where tokenstr is the AX type token as a string, converted from the provided CoreType.
static bool | nametypeFromToken (const std::string &token, std::string *name, std::string *type)
| Static method which splits a valid external token into its name and type counterparts. If the token cannot be split, neither name or type are updated and false is returned.

## Detailed Description

ExternalVariable represent any access to external (custom) data, typically associated with the '$' symbol syntax. Note that the AST does not store any additional information on the given external other than its name and type, which together form a unique external identifier known as the ExternalVariable 'token'. This token is used by the compiler to map user provided values to these external values.

Note
  The Attribute AST node works in a similar way
  An ExternalVariable is a complete "leaf-level" AST node. It has no children and nothing derives from it.

## Member Typedef Documentation

## Ptr

using Ptr = std::shared_ptr<Node>

inherited

## UniquePtr

using UniquePtr = std::unique_ptr<ExternalVariable>

## Member Enumeration Documentation

## NodeType

enum NodeType

inherited

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

Enumerator
TreeNode |
StatementListNode |
BlockNode |
ConditionalStatementNode |
CommaOperatorNode |
LoopNode |
KeywordNode |
AssignExpressionNode |
CrementNode |
UnaryOperatorNode |
BinaryOperatorNode |
TernaryOperatorNode |
CastNode |
AttributeNode |
FunctionCallNode |
ExternalVariableNode |
DeclareLocalNode |
ArrayPackNode |
ArrayUnpackNode |
LocalNode |
ValueBoolNode |
ValueInt16Node |
ValueInt32Node |
ValueInt64Node |
ValueFloatNode |
ValueDoubleNode |
ValueStrNode |

## Constructor & Destructor Documentation

## ExternalVariable() [1/3]

ExternalVariable | ( | const std::string & | name,
|  | const tokens::CoreType | type )

inline

Construct a new ExternalVariable with a given name and type.

Parameters

  name | The name of the attribute
  type | The type of the attribute

## ExternalVariable() [2/3]

ExternalVariable | ( | const std::string & | name,
|  | const std::string & | token )

inline

Construct a new ExternalVariable with a given name and type/token string, delegating construction to the above ExternalVariable constructor.

Parameters

  name | The name of the attribute
  token | The type/token string of the attribute

## ExternalVariable() [3/3]

ExternalVariable | ( | const ExternalVariable & | other | ) |

inline

Deep copy constructor for a ExternalVariable.

Note
  No parent information needs updating as an ExternalVariable is a "leaf level" node (contains no children)

Parameters

  other | A const reference to another ExternalVariable to deep copy

## ~ExternalVariable()

~ExternalVariable | ( |  | ) |

override default

## Member Function Documentation

## basetype()

const Variable * basetype | ( |  | ) | const

inline override virtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Reimplemented from Expression.

## child()

const Node * child | ( | const size_t | index | ) | const

inline override virtual inherited

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Note
  This may still return a nullptr even if the given index is valid if the child node has not been created.

Parameters

  index | The child index to query

Returns
  A Pointer to the child node, or a nullptr if none exists.

Implements Node.

## childidx()

int64_t childidx | ( |  | ) | const

inline inherited

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).

Returns
  The child index of this node

## children()

size_t children | ( |  | ) | const

inline override virtual inherited

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Returns
  The number of children this node owns.

Implements Node.

## copy()

ExternalVariable * copy | ( |  | ) | const

inline final override virtual

The deep copy method for a Node.

Implements Variable.

## isType()

template<typename NodeT>

bool isType | ( |  | ) | const

inline inherited

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## name()

const std::string & name | ( |  | ) | const

inline inherited

## nametypeFromToken()

bool nametypeFromToken | ( | const std::string & | token,
|  | std::string * | name,
|  | std::string * | type )

inline static

Static method which splits a valid external token into its name and type counterparts. If the token cannot be split, neither name or type are updated and false is returned.

Parameters

  token | The token to split.
  name | Set to the second part of the external token, representing the name. If a nullptr, it is ignored
  type | Set to the first part of the external token, representing the type. If a nullptr, it is ignored. Note that this can be empty if the external token has an inferred type or a single character.

Returns
  True if the provided external token could be split

## nodename()

const char * nodename | ( |  | ) | const

inline override virtual

Virtual method for accessing node name information.

Implements Node.

## nodetype()

NodeType nodetype | ( |  | ) | const

inline override virtual

Virtual method for accessing node type information.

Implements Node.

## parent()

const Node * parent | ( |  | ) | const

inline inherited

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## replace()

bool replace | ( | Node * | node | ) |

inline inherited

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## replacechild()

bool replacechild | ( | const size_t | index,
|  | Node * | node )

inline virtual inherited

Virtual method that attempted to replace a child at a given index with a provided node type.

Note
  See Node::replace for a more detailed description

Parameters

  index | The child index where a replacement should be attempted
  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, false otherwise

Reimplemented in ArrayPack, ArrayUnpack, AssignExpression, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, FunctionCall, Loop, StatementList, TernaryOperator, and UnaryOperator.

## setParent()

void setParent | ( | Node * | parent | ) |

inline inherited

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## subname()

const char * subname | ( |  | ) | const

inline override virtual

Virtual method for accessing node name information.

Implements Node.

## symbolseparator()

char symbolseparator | ( |  | ) |

inline static

Static method returning the symbol associated with an ExternalVariable access as defined by AX Grammar.

Returns
  The '$' character as a char

## tokenFromNameType()

std::string tokenFromNameType | ( | const std::string & | name,
|  | const tokens::CoreType | type )

inline static

Static method returning the full unique external token identifier by consolidating its name and type such that token = tokenstr + '$' + name, where tokenstr is the AX type token as a string, converted from the provided CoreType.

Note
  This identifier is unique for accesses to the same external
  Due to inferred and single character accesses in AX, this return value does not necessarily represent the original syntax used to access this external. For example, v$data will be stored and returned as vec3f$data.

Parameters

  name | The name of the external
  type | The CoreType of the external

Returns
  A string representing the external token.

## tokenname()

const std::string tokenname | ( |  | ) | const

inline

Construct and return the full external token identifier. See ExternalVariable::tokenFromNameType.

Returns
  A string representing the external variable token.

## type()

tokens::CoreType type | ( |  | ) | const

inline

Access the type that was used to access this external variable.

Returns
  The type used to access this external as a tokens::CoreType

## typestr()

std::string typestr | ( |  | ) | const

inline

Get the access type as a front end AX type/token string.

Note
  This returns the associated token to the type, not necessarily equal to the OpenVDB type string

Returns
  A string representing the type/token